/*
 * generated by Xtext 2.16.0
 */
package org.xtext.ungs.drake.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Action;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder.AbstractGrammarElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class DrakeGrammarAccess extends AbstractGrammarElementFinder {
	
	public class ModelElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.Model");
		private final Assignment cFormulationAssignment = (Assignment)rule.eContents().get(1);
		private final RuleCall cFormulationFormulationParserRuleCall_0 = (RuleCall)cFormulationAssignment.eContents().get(0);
		
		//Model:
		//	formulation+=Formulation*;
		@Override public ParserRule getRule() { return rule; }
		
		////FIXME Elegir un mejor nombre
		//formulation+=Formulation*
		public Assignment getFormulationAssignment() { return cFormulationAssignment; }
		
		//Formulation
		public RuleCall getFormulationFormulationParserRuleCall_0() { return cFormulationFormulationParserRuleCall_0; }
	}
	public class FormulationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.Formulation");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cDefinitionsAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cDefinitionsSetParserRuleCall_0_0 = (RuleCall)cDefinitionsAssignment_0.eContents().get(0);
		private final Assignment cFunctionAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final Alternatives cFunctionAlternatives_1_0 = (Alternatives)cFunctionAssignment_1.eContents().get(0);
		private final Keyword cFunctionMaxKeyword_1_0_0 = (Keyword)cFunctionAlternatives_1_0.eContents().get(0);
		private final Keyword cFunctionMinKeyword_1_0_1 = (Keyword)cFunctionAlternatives_1_0.eContents().get(1);
		private final Assignment cExpressionAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cExpressionLinearExpressionParserRuleCall_2_0 = (RuleCall)cExpressionAssignment_2.eContents().get(0);
		private final Keyword cStKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Assignment cInequationAssignment_4 = (Assignment)cGroup.eContents().get(4);
		private final RuleCall cInequationLinearInequationParserRuleCall_4_0 = (RuleCall)cInequationAssignment_4.eContents().get(0);
		private final Group cGroup_5 = (Group)cGroup.eContents().get(5);
		private final Keyword cCommaKeyword_5_0 = (Keyword)cGroup_5.eContents().get(0);
		private final Assignment cInequationAssignment_5_1 = (Assignment)cGroup_5.eContents().get(1);
		private final RuleCall cInequationLinearInequationParserRuleCall_5_1_0 = (RuleCall)cInequationAssignment_5_1.eContents().get(0);
		
		//Formulation:
		//	definitions+=Set*
		//	function=('max' | 'min') expression=LinearExpression
		//	'st' inequation+=LinearInequation (',' inequation+=LinearInequation)*;
		@Override public ParserRule getRule() { return rule; }
		
		//definitions+=Set* function=('max' | 'min') expression=LinearExpression 'st' inequation+=LinearInequation (','
		//inequation+=LinearInequation)*
		public Group getGroup() { return cGroup; }
		
		//definitions+=Set*
		public Assignment getDefinitionsAssignment_0() { return cDefinitionsAssignment_0; }
		
		//Set
		public RuleCall getDefinitionsSetParserRuleCall_0_0() { return cDefinitionsSetParserRuleCall_0_0; }
		
		//function=('max' | 'min')
		public Assignment getFunctionAssignment_1() { return cFunctionAssignment_1; }
		
		//('max' | 'min')
		public Alternatives getFunctionAlternatives_1_0() { return cFunctionAlternatives_1_0; }
		
		//'max'
		public Keyword getFunctionMaxKeyword_1_0_0() { return cFunctionMaxKeyword_1_0_0; }
		
		//'min'
		public Keyword getFunctionMinKeyword_1_0_1() { return cFunctionMinKeyword_1_0_1; }
		
		//expression=LinearExpression
		public Assignment getExpressionAssignment_2() { return cExpressionAssignment_2; }
		
		//LinearExpression
		public RuleCall getExpressionLinearExpressionParserRuleCall_2_0() { return cExpressionLinearExpressionParserRuleCall_2_0; }
		
		//'st'
		public Keyword getStKeyword_3() { return cStKeyword_3; }
		
		//inequation+=LinearInequation
		public Assignment getInequationAssignment_4() { return cInequationAssignment_4; }
		
		//LinearInequation
		public RuleCall getInequationLinearInequationParserRuleCall_4_0() { return cInequationLinearInequationParserRuleCall_4_0; }
		
		//(',' inequation+=LinearInequation)*
		public Group getGroup_5() { return cGroup_5; }
		
		//','
		public Keyword getCommaKeyword_5_0() { return cCommaKeyword_5_0; }
		
		//inequation+=LinearInequation
		public Assignment getInequationAssignment_5_1() { return cInequationAssignment_5_1; }
		
		//LinearInequation
		public RuleCall getInequationLinearInequationParserRuleCall_5_1_0() { return cInequationLinearInequationParserRuleCall_5_1_0; }
	}
	public class LinearInequationElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.LinearInequation");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cLinearExpressionAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cLinearExpressionLinearExpressionParserRuleCall_0_0 = (RuleCall)cLinearExpressionAssignment_0.eContents().get(0);
		private final Assignment cSimbolAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cSimbolSIMBOLTerminalRuleCall_1_0 = (RuleCall)cSimbolAssignment_1.eContents().get(0);
		private final Alternatives cAlternatives_2 = (Alternatives)cGroup.eContents().get(2);
		private final Assignment cVarInequalityAssignment_2_0 = (Assignment)cAlternatives_2.eContents().get(0);
		private final RuleCall cVarInequalityVariableParserRuleCall_2_0_0 = (RuleCall)cVarInequalityAssignment_2_0.eContents().get(0);
		private final Assignment cIntInequalityAssignment_2_1 = (Assignment)cAlternatives_2.eContents().get(1);
		private final RuleCall cIntInequalityINTTerminalRuleCall_2_1_0 = (RuleCall)cIntInequalityAssignment_2_1.eContents().get(0);
		
		//LinearInequation:
		//	linearExpression=LinearExpression simbol=SIMBOL (varInequality=Variable | intInequality=INT);
		@Override public ParserRule getRule() { return rule; }
		
		//linearExpression=LinearExpression simbol=SIMBOL (varInequality=Variable | intInequality=INT)
		public Group getGroup() { return cGroup; }
		
		//linearExpression=LinearExpression
		public Assignment getLinearExpressionAssignment_0() { return cLinearExpressionAssignment_0; }
		
		//LinearExpression
		public RuleCall getLinearExpressionLinearExpressionParserRuleCall_0_0() { return cLinearExpressionLinearExpressionParserRuleCall_0_0; }
		
		//simbol=SIMBOL
		public Assignment getSimbolAssignment_1() { return cSimbolAssignment_1; }
		
		//SIMBOL
		public RuleCall getSimbolSIMBOLTerminalRuleCall_1_0() { return cSimbolSIMBOLTerminalRuleCall_1_0; }
		
		//varInequality=Variable | intInequality=INT
		public Alternatives getAlternatives_2() { return cAlternatives_2; }
		
		//varInequality=Variable
		public Assignment getVarInequalityAssignment_2_0() { return cVarInequalityAssignment_2_0; }
		
		//Variable
		public RuleCall getVarInequalityVariableParserRuleCall_2_0_0() { return cVarInequalityVariableParserRuleCall_2_0_0; }
		
		//intInequality=INT
		public Assignment getIntInequalityAssignment_2_1() { return cIntInequalityAssignment_2_1; }
		
		//INT
		public RuleCall getIntInequalityINTTerminalRuleCall_2_1_0() { return cIntInequalityINTTerminalRuleCall_2_1_0; }
	}
	public class LinearExpressionElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.LinearExpression");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final Group cGroup_0 = (Group)cAlternatives.eContents().get(0);
		private final Assignment cFactorAssignment_0_0 = (Assignment)cGroup_0.eContents().get(0);
		private final RuleCall cFactorFactorParserRuleCall_0_0_0 = (RuleCall)cFactorAssignment_0_0.eContents().get(0);
		private final Group cGroup_0_1 = (Group)cGroup_0.eContents().get(1);
		private final Assignment cSimbolAssignment_0_1_0 = (Assignment)cGroup_0_1.eContents().get(0);
		private final Alternatives cSimbolAlternatives_0_1_0_0 = (Alternatives)cSimbolAssignment_0_1_0.eContents().get(0);
		private final Keyword cSimbolPlusSignKeyword_0_1_0_0_0 = (Keyword)cSimbolAlternatives_0_1_0_0.eContents().get(0);
		private final Keyword cSimbolHyphenMinusKeyword_0_1_0_0_1 = (Keyword)cSimbolAlternatives_0_1_0_0.eContents().get(1);
		private final Assignment cExpressionAssignment_0_1_1 = (Assignment)cGroup_0_1.eContents().get(1);
		private final RuleCall cExpressionLinearExpressionParserRuleCall_0_1_1_0 = (RuleCall)cExpressionAssignment_0_1_1.eContents().get(0);
		private final Assignment cValueAssignment_1 = (Assignment)cAlternatives.eContents().get(1);
		private final RuleCall cValueINTTerminalRuleCall_1_0 = (RuleCall)cValueAssignment_1.eContents().get(0);
		
		//LinearExpression:
		//	factor=Factor (simbol=('+' | '-') expression=LinearExpression)? | value=INT;
		@Override public ParserRule getRule() { return rule; }
		
		//factor=Factor (simbol=('+' | '-') expression=LinearExpression)? | value=INT
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//factor=Factor (simbol=('+' | '-') expression=LinearExpression)?
		public Group getGroup_0() { return cGroup_0; }
		
		//factor=Factor
		public Assignment getFactorAssignment_0_0() { return cFactorAssignment_0_0; }
		
		//Factor
		public RuleCall getFactorFactorParserRuleCall_0_0_0() { return cFactorFactorParserRuleCall_0_0_0; }
		
		//(simbol=('+' | '-') expression=LinearExpression)?
		public Group getGroup_0_1() { return cGroup_0_1; }
		
		//simbol=('+' | '-')
		public Assignment getSimbolAssignment_0_1_0() { return cSimbolAssignment_0_1_0; }
		
		//('+' | '-')
		public Alternatives getSimbolAlternatives_0_1_0_0() { return cSimbolAlternatives_0_1_0_0; }
		
		//'+'
		public Keyword getSimbolPlusSignKeyword_0_1_0_0_0() { return cSimbolPlusSignKeyword_0_1_0_0_0; }
		
		//'-'
		public Keyword getSimbolHyphenMinusKeyword_0_1_0_0_1() { return cSimbolHyphenMinusKeyword_0_1_0_0_1; }
		
		//expression=LinearExpression
		public Assignment getExpressionAssignment_0_1_1() { return cExpressionAssignment_0_1_1; }
		
		//LinearExpression
		public RuleCall getExpressionLinearExpressionParserRuleCall_0_1_1_0() { return cExpressionLinearExpressionParserRuleCall_0_1_1_0; }
		
		//value=INT
		public Assignment getValueAssignment_1() { return cValueAssignment_1; }
		
		//INT
		public RuleCall getValueINTTerminalRuleCall_1_0() { return cValueINTTerminalRuleCall_1_0; }
	}
	public class FactorElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.Factor");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final Group cGroup_0 = (Group)cAlternatives.eContents().get(0);
		private final Assignment cValueAssignment_0_0 = (Assignment)cGroup_0.eContents().get(0);
		private final RuleCall cValueINTTerminalRuleCall_0_0_0 = (RuleCall)cValueAssignment_0_0.eContents().get(0);
		private final Assignment cSimboloAssignment_0_1 = (Assignment)cGroup_0.eContents().get(1);
		private final Keyword cSimboloAsteriskKeyword_0_1_0 = (Keyword)cSimboloAssignment_0_1.eContents().get(0);
		private final Assignment cVariableAssignment_0_2 = (Assignment)cGroup_0.eContents().get(2);
		private final RuleCall cVariableVariableParserRuleCall_0_2_0 = (RuleCall)cVariableAssignment_0_2.eContents().get(0);
		private final Group cGroup_1 = (Group)cAlternatives.eContents().get(1);
		private final Assignment cVariableAssignment_1_0 = (Assignment)cGroup_1.eContents().get(0);
		private final RuleCall cVariableVariableParserRuleCall_1_0_0 = (RuleCall)cVariableAssignment_1_0.eContents().get(0);
		private final Assignment cSimboloAssignment_1_1 = (Assignment)cGroup_1.eContents().get(1);
		private final Keyword cSimboloAsteriskKeyword_1_1_0 = (Keyword)cSimboloAssignment_1_1.eContents().get(0);
		private final Assignment cValueAssignment_1_2 = (Assignment)cGroup_1.eContents().get(2);
		private final RuleCall cValueINTTerminalRuleCall_1_2_0 = (RuleCall)cValueAssignment_1_2.eContents().get(0);
		private final Assignment cVariableAssignment_2 = (Assignment)cAlternatives.eContents().get(2);
		private final RuleCall cVariableVariableParserRuleCall_2_0 = (RuleCall)cVariableAssignment_2.eContents().get(0);
		
		//Factor:
		//	value=INT simbolo='*' variable=Variable | variable=Variable simbolo='*' value=INT | variable=Variable;
		@Override public ParserRule getRule() { return rule; }
		
		//value=INT simbolo='*' variable=Variable | variable=Variable simbolo='*' value=INT | variable=Variable
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//value=INT simbolo='*' variable=Variable
		public Group getGroup_0() { return cGroup_0; }
		
		//value=INT
		public Assignment getValueAssignment_0_0() { return cValueAssignment_0_0; }
		
		//INT
		public RuleCall getValueINTTerminalRuleCall_0_0_0() { return cValueINTTerminalRuleCall_0_0_0; }
		
		//simbolo='*'
		public Assignment getSimboloAssignment_0_1() { return cSimboloAssignment_0_1; }
		
		//'*'
		public Keyword getSimboloAsteriskKeyword_0_1_0() { return cSimboloAsteriskKeyword_0_1_0; }
		
		//variable=Variable
		public Assignment getVariableAssignment_0_2() { return cVariableAssignment_0_2; }
		
		//Variable
		public RuleCall getVariableVariableParserRuleCall_0_2_0() { return cVariableVariableParserRuleCall_0_2_0; }
		
		//variable=Variable simbolo='*' value=INT
		public Group getGroup_1() { return cGroup_1; }
		
		//variable=Variable
		public Assignment getVariableAssignment_1_0() { return cVariableAssignment_1_0; }
		
		//Variable
		public RuleCall getVariableVariableParserRuleCall_1_0_0() { return cVariableVariableParserRuleCall_1_0_0; }
		
		//simbolo='*'
		public Assignment getSimboloAssignment_1_1() { return cSimboloAssignment_1_1; }
		
		//'*'
		public Keyword getSimboloAsteriskKeyword_1_1_0() { return cSimboloAsteriskKeyword_1_1_0; }
		
		//value=INT
		public Assignment getValueAssignment_1_2() { return cValueAssignment_1_2; }
		
		//INT
		public RuleCall getValueINTTerminalRuleCall_1_2_0() { return cValueINTTerminalRuleCall_1_2_0; }
		
		//variable=Variable
		public Assignment getVariableAssignment_2() { return cVariableAssignment_2; }
		
		//Variable
		public RuleCall getVariableVariableParserRuleCall_2_0() { return cVariableVariableParserRuleCall_2_0; }
	}
	public class SetElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.Set");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cSetKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Keyword cColonEqualsSignKeyword_2 = (Keyword)cGroup.eContents().get(2);
		private final Keyword cLeftCurlyBracketKeyword_3 = (Keyword)cGroup.eContents().get(3);
		private final Alternatives cAlternatives_4 = (Alternatives)cGroup.eContents().get(4);
		private final Group cGroup_4_0 = (Group)cAlternatives_4.eContents().get(0);
		private final Assignment cElementsAssignment_4_0_0 = (Assignment)cGroup_4_0.eContents().get(0);
		private final RuleCall cElementsTupleParserRuleCall_4_0_0_0 = (RuleCall)cElementsAssignment_4_0_0.eContents().get(0);
		private final Group cGroup_4_0_1 = (Group)cGroup_4_0.eContents().get(1);
		private final Keyword cCommaKeyword_4_0_1_0 = (Keyword)cGroup_4_0_1.eContents().get(0);
		private final Assignment cElementsAssignment_4_0_1_1 = (Assignment)cGroup_4_0_1.eContents().get(1);
		private final RuleCall cElementsTupleParserRuleCall_4_0_1_1_0 = (RuleCall)cElementsAssignment_4_0_1_1.eContents().get(0);
		private final Group cGroup_4_1 = (Group)cAlternatives_4.eContents().get(1);
		private final Assignment cLowerBoundAssignment_4_1_0 = (Assignment)cGroup_4_1.eContents().get(0);
		private final RuleCall cLowerBoundINTTerminalRuleCall_4_1_0_0 = (RuleCall)cLowerBoundAssignment_4_1_0.eContents().get(0);
		private final Keyword cToKeyword_4_1_1 = (Keyword)cGroup_4_1.eContents().get(1);
		private final Assignment cUpperBoundAssignment_4_1_2 = (Assignment)cGroup_4_1.eContents().get(2);
		private final RuleCall cUpperBoundINTTerminalRuleCall_4_1_2_0 = (RuleCall)cUpperBoundAssignment_4_1_2.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_5 = (Keyword)cGroup.eContents().get(5);
		
		//Set: //TODO Tener que en cuenta de la validación minBorder < maxBoder . Además, la langitud de cada tupla del conjunto debe ser la misma
		//	'set' name=ID ':=' '{' ((elements+=Tuple (',' elements+=Tuple)*)* | lowerBound=INT 'to' upperBound=INT) '}';
		@Override public ParserRule getRule() { return rule; }
		
		////TODO Tener que en cuenta de la validación minBorder < maxBoder . Además, la langitud de cada tupla del conjunto debe ser la misma
		//'set' name=ID ':=' '{' ((elements+=Tuple (',' elements+=Tuple)*)* | lowerBound=INT 'to' upperBound=INT) '}'
		public Group getGroup() { return cGroup; }
		
		////TODO Tener que en cuenta de la validación minBorder < maxBoder . Además, la langitud de cada tupla del conjunto debe ser la misma
		//'set'
		public Keyword getSetKeyword_0() { return cSetKeyword_0; }
		
		//name=ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//':='
		public Keyword getColonEqualsSignKeyword_2() { return cColonEqualsSignKeyword_2; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_3() { return cLeftCurlyBracketKeyword_3; }
		
		//(elements+=Tuple (',' elements+=Tuple)*)* | lowerBound=INT 'to' upperBound=INT
		public Alternatives getAlternatives_4() { return cAlternatives_4; }
		
		//(elements+=Tuple (',' elements+=Tuple)*)*
		public Group getGroup_4_0() { return cGroup_4_0; }
		
		//elements+=Tuple
		public Assignment getElementsAssignment_4_0_0() { return cElementsAssignment_4_0_0; }
		
		//Tuple
		public RuleCall getElementsTupleParserRuleCall_4_0_0_0() { return cElementsTupleParserRuleCall_4_0_0_0; }
		
		//(',' elements+=Tuple)*
		public Group getGroup_4_0_1() { return cGroup_4_0_1; }
		
		//','
		public Keyword getCommaKeyword_4_0_1_0() { return cCommaKeyword_4_0_1_0; }
		
		//elements+=Tuple
		public Assignment getElementsAssignment_4_0_1_1() { return cElementsAssignment_4_0_1_1; }
		
		//Tuple
		public RuleCall getElementsTupleParserRuleCall_4_0_1_1_0() { return cElementsTupleParserRuleCall_4_0_1_1_0; }
		
		//lowerBound=INT 'to' upperBound=INT
		public Group getGroup_4_1() { return cGroup_4_1; }
		
		//lowerBound=INT
		public Assignment getLowerBoundAssignment_4_1_0() { return cLowerBoundAssignment_4_1_0; }
		
		//INT
		public RuleCall getLowerBoundINTTerminalRuleCall_4_1_0_0() { return cLowerBoundINTTerminalRuleCall_4_1_0_0; }
		
		//'to'
		public Keyword getToKeyword_4_1_1() { return cToKeyword_4_1_1; }
		
		//upperBound=INT
		public Assignment getUpperBoundAssignment_4_1_2() { return cUpperBoundAssignment_4_1_2; }
		
		//INT
		public RuleCall getUpperBoundINTTerminalRuleCall_4_1_2_0() { return cUpperBoundINTTerminalRuleCall_4_1_2_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_5() { return cRightCurlyBracketKeyword_5; }
	}
	public class TupleElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.Tuple");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Action cTupleAction_0 = (Action)cGroup.eContents().get(0);
		private final Keyword cLessThanSignKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Group cGroup_2 = (Group)cGroup.eContents().get(2);
		private final Assignment cElementsAssignment_2_0 = (Assignment)cGroup_2.eContents().get(0);
		private final RuleCall cElementsElementParserRuleCall_2_0_0 = (RuleCall)cElementsAssignment_2_0.eContents().get(0);
		private final Group cGroup_2_1 = (Group)cGroup_2.eContents().get(1);
		private final Keyword cCommaKeyword_2_1_0 = (Keyword)cGroup_2_1.eContents().get(0);
		private final Assignment cElementsAssignment_2_1_1 = (Assignment)cGroup_2_1.eContents().get(1);
		private final RuleCall cElementsElementParserRuleCall_2_1_1_0 = (RuleCall)cElementsAssignment_2_1_1.eContents().get(0);
		private final Keyword cGreaterThanSignKeyword_3 = (Keyword)cGroup.eContents().get(3);
		
		//Tuple:
		//	{Tuple} '<' (elements+=Element (',' elements+=Element)*)* '>';
		@Override public ParserRule getRule() { return rule; }
		
		//{Tuple} '<' (elements+=Element (',' elements+=Element)*)* '>'
		public Group getGroup() { return cGroup; }
		
		//{Tuple}
		public Action getTupleAction_0() { return cTupleAction_0; }
		
		//'<'
		public Keyword getLessThanSignKeyword_1() { return cLessThanSignKeyword_1; }
		
		//(elements+=Element (',' elements+=Element)*)*
		public Group getGroup_2() { return cGroup_2; }
		
		//elements+=Element
		public Assignment getElementsAssignment_2_0() { return cElementsAssignment_2_0; }
		
		//Element
		public RuleCall getElementsElementParserRuleCall_2_0_0() { return cElementsElementParserRuleCall_2_0_0; }
		
		//(',' elements+=Element)*
		public Group getGroup_2_1() { return cGroup_2_1; }
		
		//','
		public Keyword getCommaKeyword_2_1_0() { return cCommaKeyword_2_1_0; }
		
		//elements+=Element
		public Assignment getElementsAssignment_2_1_1() { return cElementsAssignment_2_1_1; }
		
		//Element
		public RuleCall getElementsElementParserRuleCall_2_1_1_0() { return cElementsElementParserRuleCall_2_1_1_0; }
		
		//'>'
		public Keyword getGreaterThanSignKeyword_3() { return cGreaterThanSignKeyword_3; }
	}
	public class ElementElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.Element");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final Assignment cValueAssignment_0 = (Assignment)cAlternatives.eContents().get(0);
		private final RuleCall cValueINTTerminalRuleCall_0_0 = (RuleCall)cValueAssignment_0.eContents().get(0);
		private final Assignment cStringAssignment_1 = (Assignment)cAlternatives.eContents().get(1);
		private final RuleCall cStringSTRINGTerminalRuleCall_1_0 = (RuleCall)cStringAssignment_1.eContents().get(0);
		private final Assignment cVariableAssignment_2 = (Assignment)cAlternatives.eContents().get(2);
		private final RuleCall cVariableVariableParserRuleCall_2_0 = (RuleCall)cVariableAssignment_2.eContents().get(0);
		private final Assignment cTupleAssignment_3 = (Assignment)cAlternatives.eContents().get(3);
		private final RuleCall cTupleTupleParserRuleCall_3_0 = (RuleCall)cTupleAssignment_3.eContents().get(0);
		
		//Element:
		//	value=INT | string=STRING | variable=Variable | tuple=Tuple;
		@Override public ParserRule getRule() { return rule; }
		
		//value=INT | string=STRING | variable=Variable | tuple=Tuple
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//value=INT
		public Assignment getValueAssignment_0() { return cValueAssignment_0; }
		
		//INT
		public RuleCall getValueINTTerminalRuleCall_0_0() { return cValueINTTerminalRuleCall_0_0; }
		
		//string=STRING
		public Assignment getStringAssignment_1() { return cStringAssignment_1; }
		
		//STRING
		public RuleCall getStringSTRINGTerminalRuleCall_1_0() { return cStringSTRINGTerminalRuleCall_1_0; }
		
		//variable=Variable
		public Assignment getVariableAssignment_2() { return cVariableAssignment_2; }
		
		//Variable
		public RuleCall getVariableVariableParserRuleCall_2_0() { return cVariableVariableParserRuleCall_2_0; }
		
		//tuple=Tuple
		public Assignment getTupleAssignment_3() { return cTupleAssignment_3; }
		
		//Tuple
		public RuleCall getTupleTupleParserRuleCall_3_0() { return cTupleTupleParserRuleCall_3_0; }
	}
	public class VariableElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.Variable");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cNameIDTerminalRuleCall_0_0 = (RuleCall)cNameAssignment_0.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword c_Keyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final Alternatives cAlternatives_1_1 = (Alternatives)cGroup_1.eContents().get(1);
		private final Assignment cIndexAssignment_1_1_0 = (Assignment)cAlternatives_1_1.eContents().get(0);
		private final RuleCall cIndexINTTerminalRuleCall_1_1_0_0 = (RuleCall)cIndexAssignment_1_1_0.eContents().get(0);
		private final Group cGroup_1_1_1 = (Group)cAlternatives_1_1.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_1_1_1_0 = (Keyword)cGroup_1_1_1.eContents().get(0);
		private final Assignment cIndexAssignment_1_1_1_1 = (Assignment)cGroup_1_1_1.eContents().get(1);
		private final RuleCall cIndexINTTerminalRuleCall_1_1_1_1_0 = (RuleCall)cIndexAssignment_1_1_1_1.eContents().get(0);
		private final Group cGroup_1_1_1_2 = (Group)cGroup_1_1_1.eContents().get(2);
		private final Keyword cCommaKeyword_1_1_1_2_0 = (Keyword)cGroup_1_1_1_2.eContents().get(0);
		private final Assignment cIndexAssignment_1_1_1_2_1 = (Assignment)cGroup_1_1_1_2.eContents().get(1);
		private final RuleCall cIndexINTTerminalRuleCall_1_1_1_2_1_0 = (RuleCall)cIndexAssignment_1_1_1_2_1.eContents().get(0);
		private final Keyword cRightCurlyBracketKeyword_1_1_1_3 = (Keyword)cGroup_1_1_1.eContents().get(3);
		
		//Variable:
		//	name=ID ('_' (index+=INT | '{' index+=INT (',' index+=INT)? '}'))?;
		@Override public ParserRule getRule() { return rule; }
		
		//name=ID ('_' (index+=INT | '{' index+=INT (',' index+=INT)? '}'))?
		public Group getGroup() { return cGroup; }
		
		//name=ID
		public Assignment getNameAssignment_0() { return cNameAssignment_0; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_0_0() { return cNameIDTerminalRuleCall_0_0; }
		
		//('_' (index+=INT | '{' index+=INT (',' index+=INT)? '}'))?
		public Group getGroup_1() { return cGroup_1; }
		
		//'_'
		public Keyword get_Keyword_1_0() { return c_Keyword_1_0; }
		
		//index+=INT | '{' index+=INT (',' index+=INT)? '}'
		public Alternatives getAlternatives_1_1() { return cAlternatives_1_1; }
		
		//index+=INT
		public Assignment getIndexAssignment_1_1_0() { return cIndexAssignment_1_1_0; }
		
		//INT
		public RuleCall getIndexINTTerminalRuleCall_1_1_0_0() { return cIndexINTTerminalRuleCall_1_1_0_0; }
		
		//'{' index+=INT (',' index+=INT)? '}'
		public Group getGroup_1_1_1() { return cGroup_1_1_1; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_1_1_1_0() { return cLeftCurlyBracketKeyword_1_1_1_0; }
		
		//index+=INT
		public Assignment getIndexAssignment_1_1_1_1() { return cIndexAssignment_1_1_1_1; }
		
		//INT
		public RuleCall getIndexINTTerminalRuleCall_1_1_1_1_0() { return cIndexINTTerminalRuleCall_1_1_1_1_0; }
		
		//(',' index+=INT)?
		public Group getGroup_1_1_1_2() { return cGroup_1_1_1_2; }
		
		//','
		public Keyword getCommaKeyword_1_1_1_2_0() { return cCommaKeyword_1_1_1_2_0; }
		
		//index+=INT
		public Assignment getIndexAssignment_1_1_1_2_1() { return cIndexAssignment_1_1_1_2_1; }
		
		//INT
		public RuleCall getIndexINTTerminalRuleCall_1_1_1_2_1_0() { return cIndexINTTerminalRuleCall_1_1_1_2_1_0; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_1_1_1_3() { return cRightCurlyBracketKeyword_1_1_1_3; }
	}
	
	
	private final ModelElements pModel;
	private final FormulationElements pFormulation;
	private final LinearInequationElements pLinearInequation;
	private final LinearExpressionElements pLinearExpression;
	private final FactorElements pFactor;
	private final SetElements pSet;
	private final TupleElements pTuple;
	private final ElementElements pElement;
	private final VariableElements pVariable;
	private final TerminalRule tID;
	private final TerminalRule tSIMBOL;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public DrakeGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pModel = new ModelElements();
		this.pFormulation = new FormulationElements();
		this.pLinearInequation = new LinearInequationElements();
		this.pLinearExpression = new LinearExpressionElements();
		this.pFactor = new FactorElements();
		this.pSet = new SetElements();
		this.pTuple = new TupleElements();
		this.pElement = new ElementElements();
		this.pVariable = new VariableElements();
		this.tID = (TerminalRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.ID");
		this.tSIMBOL = (TerminalRule) GrammarUtil.findRuleForName(getGrammar(), "org.xtext.ungs.drake.Drake.SIMBOL");
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("org.xtext.ungs.drake.Drake".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//Model:
	//	formulation+=Formulation*;
	public ModelElements getModelAccess() {
		return pModel;
	}
	
	public ParserRule getModelRule() {
		return getModelAccess().getRule();
	}
	
	//Formulation:
	//	definitions+=Set*
	//	function=('max' | 'min') expression=LinearExpression
	//	'st' inequation+=LinearInequation (',' inequation+=LinearInequation)*;
	public FormulationElements getFormulationAccess() {
		return pFormulation;
	}
	
	public ParserRule getFormulationRule() {
		return getFormulationAccess().getRule();
	}
	
	//LinearInequation:
	//	linearExpression=LinearExpression simbol=SIMBOL (varInequality=Variable | intInequality=INT);
	public LinearInequationElements getLinearInequationAccess() {
		return pLinearInequation;
	}
	
	public ParserRule getLinearInequationRule() {
		return getLinearInequationAccess().getRule();
	}
	
	//LinearExpression:
	//	factor=Factor (simbol=('+' | '-') expression=LinearExpression)? | value=INT;
	public LinearExpressionElements getLinearExpressionAccess() {
		return pLinearExpression;
	}
	
	public ParserRule getLinearExpressionRule() {
		return getLinearExpressionAccess().getRule();
	}
	
	//Factor:
	//	value=INT simbolo='*' variable=Variable | variable=Variable simbolo='*' value=INT | variable=Variable;
	public FactorElements getFactorAccess() {
		return pFactor;
	}
	
	public ParserRule getFactorRule() {
		return getFactorAccess().getRule();
	}
	
	//Set: //TODO Tener que en cuenta de la validación minBorder < maxBoder . Además, la langitud de cada tupla del conjunto debe ser la misma
	//	'set' name=ID ':=' '{' ((elements+=Tuple (',' elements+=Tuple)*)* | lowerBound=INT 'to' upperBound=INT) '}';
	public SetElements getSetAccess() {
		return pSet;
	}
	
	public ParserRule getSetRule() {
		return getSetAccess().getRule();
	}
	
	//Tuple:
	//	{Tuple} '<' (elements+=Element (',' elements+=Element)*)* '>';
	public TupleElements getTupleAccess() {
		return pTuple;
	}
	
	public ParserRule getTupleRule() {
		return getTupleAccess().getRule();
	}
	
	//Element:
	//	value=INT | string=STRING | variable=Variable | tuple=Tuple;
	public ElementElements getElementAccess() {
		return pElement;
	}
	
	public ParserRule getElementRule() {
		return getElementAccess().getRule();
	}
	
	//Variable:
	//	name=ID ('_' (index+=INT | '{' index+=INT (',' index+=INT)? '}'))?;
	public VariableElements getVariableAccess() {
		return pVariable;
	}
	
	public ParserRule getVariableRule() {
		return getVariableAccess().getRule();
	}
	
	//@Override
	//terminal ID:
	//	'a'..'z' | 'A'..'Z'+
	//	//Si quiero agregar INT como un terminal de ID obtengo
	//	//The following token definitions can never be matched because prior tokens match the same input: RULE_INT
	//	//Además faltan agregar los espacios en blanco (La veo complicada)
	//;
	public TerminalRule getIDRule() {
		return tID;
	}
	
	//terminal SIMBOL:
	//	'>=' | '<=' | '=';
	public TerminalRule getSIMBOLRule() {
		return tSIMBOL;
	}
	
	//terminal INT returns ecore::EInt:
	//	'0'..'9'+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal STRING:
	//	'"' ('\\' . | !('\\' | '"'))* '"' |
	//	"'" ('\\' . | !('\\' | "'"))* "'";
	public TerminalRule getSTRINGRule() {
		return gaTerminals.getSTRINGRule();
	}
	
	//terminal ML_COMMENT:
	//	'/*'->'*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT:
	//	'//' !('\n' | '\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS:
	//	' ' | '\t' | '\r' | '\n'+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER:
	//	.;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
